import React, { useState } from 'react';
import { NextPage } from "next";
import InputCustom from '../components/InputCustom';
import { useForm } from 'react-hook-form';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faSpinner } from '@fortawesome/free-solid-svg-icons';
import AuthService from '../lib/api/auth';
import useSWR, { mutate } from 'swr';
import Router from 'next/router';
import Head from 'next/head';
import ToastHelper from '../utils/toast';
import storage from '../utils/storage';

const Login: NextPage = () => {
  const { data: user } = useSWR('user', storage);
  if (user) Router.push('/');
  
  const {
    register,
    handleSubmit,
    formState: { errors },
  } = useForm();
  
  const [loading, setLoading] = useState(false);
  const submitLogin = async (req: any) => {
    setLoading(true);
    const { email, password } = req;
    const { data, status } = await AuthService.login(email, password);
    console.log(status);
    if (status != 200) ToastHelper.error({ title: data?.error?.message });
    if (data?.user) {
      window.localStorage.setItem('user', JSON.stringify(data?.user));
      window.localStorage.setItem('token', data?.jwt);

      mutate("user", data.user);
      mutate("token", data.jwt);

      ToastHelper.success({ title: 'Login Success' });
      Router.push("/");
    }
    setLoading(false);
  };

  return (
    <div>
      <Head>
        <title>Login | Movie Watchlist</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/favicon.ico" />
      </Head>
      <div className="flex flex-col my-20">
        <div className="grid place-items-center mx-2 my-20 sm:my-auto">
          <div
            className="w-11/12 p-12 sm:w-8/12 md:w-6/12 lg:w-5/12 2xl:w-4/12 
              px-6 py-10 sm:px-10 sm:py-6 
              bg-white rounded-lg shadow-md lg:shadow-lg"
          >
            <h2 className="text-center font-semibold text-3xl lg:text-4xl text-gray-800">
              Login
              </h2>

            <form className="mt-10" onSubmit={handleSubmit(submitLogin)}>
              <div className="form-group mb-4">
                <InputCustom
                  title="Email"
                  type="text"
                  placeholder="Enter email"
                  registerField={register('email', {
                    required: 'Email required',
                    pattern: {
                      value: /^\S+@\S+$/i,
                      message: 'Please email pattern (ex: test@mail.com)',
                    },
                  })}
                  errors={errors.email}
                />
              </div>
              <div className="form-group mb-4">
                <InputCustom
                  title="Password"
                  type="password"
                  placeholder="Enter password"
                  registerField={register('password', {
                    required: 'Password required',
                  })}
                  errors={errors.password}
                />
              </div>

              <button
                type="submit"
                disabled={loading}
                className="w-full py-3 bg-gray-800 rounded-sm
                      font-medium text-white uppercase
                      focus:outline-none hover:bg-gray-700 hover:shadow-none"
              >
                {loading ? (
                  <FontAwesomeIcon icon={faSpinner} className="spinner" size="sm" />
                ) : (
                  'Login'
                )}
              </button>

              <div className="sm:flex sm:flex-wrap mt-8 sm:mb-4 text-sm text-center">
                <a href="forgot-password" className="flex-2 underline">
                  Forgot password?
                  </a>

                <p className="flex-1 text-gray-500 text-md mx-4 my-1 sm:my-auto">
                  or
                  </p>

                <a href="register" className="flex-2 underline">
                  Create an Account
                  </a>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
  )
};

export default Login;